import type { DevnetUrl, MainnetUrl, TestnetUrl } from "@solana/rpc-types";
import type { LocalnetUrl, SolanaClient, ModifiedClusterUrl, CreateSolanaClientArgs } from "../types/rpc";
/**
 * Create a Solana `rpc` and `rpcSubscriptions` client
 */
export declare function createSolanaClient(props: Omit<CreateSolanaClientArgs<MainnetUrl | "mainnet">, "urlOrMoniker"> & {
    urlOrMoniker: "mainnet";
}): SolanaClient<MainnetUrl>;
export declare function createSolanaClient(props: Omit<CreateSolanaClientArgs<DevnetUrl | "devnet">, "urlOrMoniker"> & {
    urlOrMoniker: "devnet";
}): SolanaClient<DevnetUrl>;
export declare function createSolanaClient(props: Omit<CreateSolanaClientArgs<TestnetUrl | "testnet">, "urlOrMoniker"> & {
    urlOrMoniker: "testnet";
}): SolanaClient<TestnetUrl>;
export declare function createSolanaClient(props: Omit<CreateSolanaClientArgs<LocalnetUrl | "localnet">, "urlOrMoniker"> & {
    urlOrMoniker: "localnet";
}): SolanaClient<LocalnetUrl>;
export declare function createSolanaClient<TClusterUrl extends ModifiedClusterUrl>(props: CreateSolanaClientArgs<TClusterUrl>): SolanaClient<TClusterUrl>;
//# sourceMappingURL=create-solana-client.d.ts.map