import { COMPUTE_BUDGET_PROGRAM_ADDRESS } from "@solana-program/compute-budget";
import { type IInstruction, type IInstructionWithData } from "@solana/instructions";
import type { TransactionMessage } from "@solana/transaction-messages";
/**
 * Check if a given instruction is a `SetComputeUnitLimit` instruction
 */
export declare function isSetComputeLimitInstruction(instruction: IInstruction): instruction is IInstruction<typeof COMPUTE_BUDGET_PROGRAM_ADDRESS> & IInstructionWithData<Uint8Array>;
/**
 * Check if a given transaction contains a `SetComputeUnitLimit` instruction
 */
export declare function hasSetComputeLimitInstruction(tx: TransactionMessage): boolean;
/**
 * Check if a given instruction is a `SetComputeUnitPrice` instruction
 */
export declare function isSetComputeUnitPriceInstruction(instruction: IInstruction): instruction is IInstruction<typeof COMPUTE_BUDGET_PROGRAM_ADDRESS> & IInstructionWithData<Uint8Array>;
/**
 * Check if a given transaction contains a `SetComputeUnitPrice` instruction
 */
export declare function hasSetComputeUnitPriceInstruction(tx: TransactionMessage): boolean;
//# sourceMappingURL=compute-budget.d.ts.map