export * from '@solana-program/system';
export * from '@solana-program/address-lookup-table';
import { COMPUTE_BUDGET_PROGRAM_ADDRESS } from '@solana-program/compute-budget';
export * from '@solana-program/compute-budget';
import { IInstruction, IInstructionWithData, IAccountMeta, IInstructionWithAccounts, WritableAccount, ReadonlyAccount, ReadonlySignerAccount, WritableSignerAccount } from '@solana/instructions';
import { TransactionMessage } from '@solana/transaction-messages';
import { Encoder, Decoder, Codec, ReadonlyUint8Array, GetDiscriminatedUnionVariantContent, GetDiscriminatedUnionVariant, Option, OptionOrNullable } from '@solana/codecs';
import { Address } from '@solana/addresses';
import { TransactionSigner, IAccountSignerMeta, KeyPairSigner } from '@solana/signers';

/**
 * Check if a given instruction is a `SetComputeUnitLimit` instruction
 */
declare function isSetComputeLimitInstruction(instruction: IInstruction): instruction is IInstruction<typeof COMPUTE_BUDGET_PROGRAM_ADDRESS> & IInstructionWithData<Uint8Array>;
/**
 * Check if a given transaction contains a `SetComputeUnitLimit` instruction
 */
declare function hasSetComputeLimitInstruction(tx: TransactionMessage): boolean;
/**
 * Check if a given instruction is a `SetComputeUnitPrice` instruction
 */
declare function isSetComputeUnitPriceInstruction(instruction: IInstruction): instruction is IInstruction<typeof COMPUTE_BUDGET_PROGRAM_ADDRESS> & IInstructionWithData<Uint8Array>;
/**
 * Check if a given transaction contains a `SetComputeUnitPrice` instruction
 */
declare function hasSetComputeUnitPriceInstruction(tx: TransactionMessage): boolean;

/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */

declare const MEMO_PROGRAM_ADDRESS: Address<"MemoSq4gqABAXKb96qnH8TysNcWxMyWCqXgDLGmfcHr">;
declare enum MemoInstruction {
    AddMemo = 0
}
type ParsedMemoInstruction<TProgram extends string = "MemoSq4gqABAXKb96qnH8TysNcWxMyWCqXgDLGmfcHr"> = {
    instructionType: MemoInstruction.AddMemo;
} & ParsedAddMemoInstruction<TProgram>;

/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */

type AddMemoInstruction<TProgram extends string = typeof MEMO_PROGRAM_ADDRESS, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<TRemainingAccounts>;
type AddMemoInstructionData = {
    memo: string;
};
type AddMemoInstructionDataArgs = AddMemoInstructionData;
declare function getAddMemoInstructionDataEncoder(): Encoder<AddMemoInstructionDataArgs>;
declare function getAddMemoInstructionDataDecoder(): Decoder<AddMemoInstructionData>;
declare function getAddMemoInstructionDataCodec(): Codec<AddMemoInstructionDataArgs, AddMemoInstructionData>;
type AddMemoInput = {
    memo: AddMemoInstructionDataArgs["memo"];
    signers?: Array<TransactionSigner>;
};
declare function getAddMemoInstruction<TProgramAddress extends Address = typeof MEMO_PROGRAM_ADDRESS>(input: AddMemoInput, config?: {
    programAddress?: TProgramAddress;
}): AddMemoInstruction<TProgramAddress>;
type ParsedAddMemoInstruction<TProgram extends string = typeof MEMO_PROGRAM_ADDRESS> = {
    programAddress: Address<TProgram>;
    data: AddMemoInstructionData;
};
declare function parseAddMemoInstruction<TProgram extends string>(instruction: IInstruction<TProgram> & IInstructionWithData<Uint8Array>): ParsedAddMemoInstruction<TProgram>;

/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */

type Collection = {
    verified: boolean;
    key: Address;
};
type CollectionArgs = Collection;
declare function getCollectionEncoder(): Encoder<CollectionArgs>;
declare function getCollectionDecoder(): Decoder<Collection>;
declare function getCollectionCodec(): Codec<CollectionArgs, Collection>;

/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */

type CollectionDetails = {
    __kind: "V1";
    size: bigint;
} | {
    __kind: "V2";
    padding: ReadonlyUint8Array;
};
type CollectionDetailsArgs = {
    __kind: "V1";
    size: number | bigint;
} | {
    __kind: "V2";
    padding: ReadonlyUint8Array;
};
declare function getCollectionDetailsEncoder(): Encoder<CollectionDetailsArgs>;
declare function getCollectionDetailsDecoder(): Decoder<CollectionDetails>;
declare function getCollectionDetailsCodec(): Codec<CollectionDetailsArgs, CollectionDetails>;
declare function collectionDetails(kind: "V1", data: GetDiscriminatedUnionVariantContent<CollectionDetailsArgs, "__kind", "V1">): GetDiscriminatedUnionVariant<CollectionDetailsArgs, "__kind", "V1">;
declare function collectionDetails(kind: "V2", data: GetDiscriminatedUnionVariantContent<CollectionDetailsArgs, "__kind", "V2">): GetDiscriminatedUnionVariant<CollectionDetailsArgs, "__kind", "V2">;
declare function isCollectionDetails<K extends CollectionDetails["__kind"]>(kind: K, value: CollectionDetails): value is CollectionDetails & {
    __kind: K;
};

/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */

type CollectionDetailsToggle = {
    __kind: "None";
} | {
    __kind: "Clear";
} | {
    __kind: "Set";
    fields: readonly [CollectionDetails];
};
type CollectionDetailsToggleArgs = {
    __kind: "None";
} | {
    __kind: "Clear";
} | {
    __kind: "Set";
    fields: readonly [CollectionDetailsArgs];
};
declare function getCollectionDetailsToggleEncoder(): Encoder<CollectionDetailsToggleArgs>;
declare function getCollectionDetailsToggleDecoder(): Decoder<CollectionDetailsToggle>;
declare function getCollectionDetailsToggleCodec(): Codec<CollectionDetailsToggleArgs, CollectionDetailsToggle>;
declare function collectionDetailsToggle(kind: "None"): GetDiscriminatedUnionVariant<CollectionDetailsToggleArgs, "__kind", "None">;
declare function collectionDetailsToggle(kind: "Clear"): GetDiscriminatedUnionVariant<CollectionDetailsToggleArgs, "__kind", "Clear">;
declare function collectionDetailsToggle(kind: "Set", data: GetDiscriminatedUnionVariantContent<CollectionDetailsToggleArgs, "__kind", "Set">["fields"]): GetDiscriminatedUnionVariant<CollectionDetailsToggleArgs, "__kind", "Set">;
declare function isCollectionDetailsToggle<K extends CollectionDetailsToggle["__kind"]>(kind: K, value: CollectionDetailsToggle): value is CollectionDetailsToggle & {
    __kind: K;
};

/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */

type Creator = {
    address: Address;
    verified: boolean;
    share: number;
};
type CreatorArgs = Creator;
declare function getCreatorEncoder(): Encoder<CreatorArgs>;
declare function getCreatorDecoder(): Decoder<Creator>;
declare function getCreatorCodec(): Codec<CreatorArgs, Creator>;

/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */

type DataV2 = {
    name: string;
    symbol: string;
    uri: string;
    sellerFeeBasisPoints: number;
    creators: Option<Array<Creator>>;
    collection: Option<Collection>;
    uses: Option<Uses>;
};
type DataV2Args = {
    name: string;
    symbol: string;
    uri: string;
    sellerFeeBasisPoints: number;
    creators: OptionOrNullable<Array<CreatorArgs>>;
    collection: OptionOrNullable<CollectionArgs>;
    uses: OptionOrNullable<UsesArgs>;
};
declare function getDataV2Encoder(): Encoder<DataV2Args>;
declare function getDataV2Decoder(): Decoder<DataV2>;
declare function getDataV2Codec(): Codec<DataV2Args, DataV2>;

/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */

type Uses = {
    useMethod: UseMethod;
    remaining: bigint;
    total: bigint;
};
type UsesArgs = {
    useMethod: UseMethodArgs;
    remaining: number | bigint;
    total: number | bigint;
};
declare function getUsesEncoder(): Encoder<UsesArgs>;
declare function getUsesDecoder(): Decoder<Uses>;
declare function getUsesCodec(): Codec<UsesArgs, Uses>;

/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */

declare enum UseMethod {
    Burn = 0,
    Multiple = 1,
    Single = 2
}
type UseMethodArgs = UseMethod;
declare function getUseMethodEncoder(): Encoder<UseMethodArgs>;
declare function getUseMethodDecoder(): Decoder<UseMethod>;
declare function getUseMethodCodec(): Codec<UseMethodArgs, UseMethod>;

/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */

declare const CREATE_METADATA_ACCOUNT_V3_DISCRIMINATOR = 33;
declare const TOKEN_METADATA_PROGRAM_ADDRESS: Address<"metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s">;
declare function getCreateMetadataAccountV3DiscriminatorBytes(): ReadonlyUint8Array;
type CreateMetadataAccountV3Instruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountMintAuthority extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountUpdateAuthority extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = "11111111111111111111111111111111", TAccountRent extends string | IAccountMeta<string> | undefined = undefined, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountMintAuthority extends string ? ReadonlySignerAccount<TAccountMintAuthority> & IAccountSignerMeta<TAccountMintAuthority> : TAccountMintAuthority,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountUpdateAuthority extends string ? ReadonlyAccount<TAccountUpdateAuthority> : TAccountUpdateAuthority,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...(TAccountRent extends undefined ? [] : [TAccountRent extends string ? ReadonlyAccount<TAccountRent> : TAccountRent]),
    ...TRemainingAccounts
]>;
type CreateMetadataAccountV3InstructionData = {
    discriminator: number;
    data: DataV2;
    isMutable: boolean;
    collectionDetails: Option<CollectionDetails>;
};
type CreateMetadataAccountV3InstructionDataArgs = {
    data: DataV2Args;
    isMutable: boolean;
    collectionDetails: OptionOrNullable<CollectionDetailsArgs>;
};
declare function getCreateMetadataAccountV3InstructionDataEncoder(): Encoder<CreateMetadataAccountV3InstructionDataArgs>;
declare function getCreateMetadataAccountV3InstructionDataDecoder(): Decoder<CreateMetadataAccountV3InstructionData>;
declare function getCreateMetadataAccountV3InstructionDataCodec(): Codec<CreateMetadataAccountV3InstructionDataArgs, CreateMetadataAccountV3InstructionData>;
type CreateMetadataAccountV3Input<TAccountMetadata extends string = string, TAccountMint extends string = string, TAccountMintAuthority extends string = string, TAccountPayer extends string = string, TAccountUpdateAuthority extends string = string, TAccountSystemProgram extends string = string, TAccountRent extends string = string> = {
    /** Metadata key (pda of ['metadata', program id, mint id]) */
    metadata: Address<TAccountMetadata>;
    /** Mint of token asset */
    mint: Address<TAccountMint>;
    /** Mint authority */
    mintAuthority: TransactionSigner<TAccountMintAuthority>;
    /** payer */
    payer: TransactionSigner<TAccountPayer>;
    /** update authority info */
    updateAuthority: Address<TAccountUpdateAuthority> | TransactionSigner<TAccountUpdateAuthority>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Rent info */
    rent?: Address<TAccountRent>;
    data: CreateMetadataAccountV3InstructionDataArgs["data"];
    isMutable: CreateMetadataAccountV3InstructionDataArgs["isMutable"];
    collectionDetails: CreateMetadataAccountV3InstructionDataArgs["collectionDetails"];
};
declare function getCreateMetadataAccountV3Instruction<TAccountMetadata extends string, TAccountMint extends string, TAccountMintAuthority extends string, TAccountPayer extends string, TAccountUpdateAuthority extends string, TAccountSystemProgram extends string, TAccountRent extends string, TProgramAddress extends Address = typeof TOKEN_METADATA_PROGRAM_ADDRESS>(input: CreateMetadataAccountV3Input<TAccountMetadata, TAccountMint, TAccountMintAuthority, TAccountPayer, TAccountUpdateAuthority, TAccountSystemProgram, TAccountRent>, config?: {
    programAddress?: TProgramAddress;
}): CreateMetadataAccountV3Instruction<TProgramAddress, TAccountMetadata, TAccountMint, TAccountMintAuthority, TAccountPayer, (typeof input)["updateAuthority"] extends TransactionSigner<TAccountUpdateAuthority> ? ReadonlySignerAccount<TAccountUpdateAuthority> & IAccountSignerMeta<TAccountUpdateAuthority> : TAccountUpdateAuthority, TAccountSystemProgram, TAccountRent>;
type ParsedCreateMetadataAccountV3Instruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Metadata key (pda of ['metadata', program id, mint id]) */
        metadata: TAccountMetas[0];
        /** Mint of token asset */
        mint: TAccountMetas[1];
        /** Mint authority */
        mintAuthority: TAccountMetas[2];
        /** payer */
        payer: TAccountMetas[3];
        /** update authority info */
        updateAuthority: TAccountMetas[4];
        /** System program */
        systemProgram: TAccountMetas[5];
        /** Rent info */
        rent?: TAccountMetas[6] | undefined;
    };
    data: CreateMetadataAccountV3InstructionData;
};
declare function parseCreateMetadataAccountV3Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCreateMetadataAccountV3Instruction<TProgram, TAccountMetas>;

/**
 * Derive the Token Metadata address from a token's mint address
 *
 * @param `mint` - `Address` or `KeyPairSigner` of the token mint
 */
declare function getTokenMetadataAddress(mint: Address | KeyPairSigner): Promise<Address>;

export { type AddMemoInput, type AddMemoInstruction, type AddMemoInstructionData, type AddMemoInstructionDataArgs, CREATE_METADATA_ACCOUNT_V3_DISCRIMINATOR, type Collection, type CollectionArgs, type CollectionDetails, type CollectionDetailsArgs, type CollectionDetailsToggle, type CollectionDetailsToggleArgs, type CreateMetadataAccountV3Input, type CreateMetadataAccountV3Instruction, type CreateMetadataAccountV3InstructionData, type CreateMetadataAccountV3InstructionDataArgs, type Creator, type CreatorArgs, type DataV2, type DataV2Args, MEMO_PROGRAM_ADDRESS, MemoInstruction, type ParsedAddMemoInstruction, type ParsedCreateMetadataAccountV3Instruction, type ParsedMemoInstruction, TOKEN_METADATA_PROGRAM_ADDRESS, UseMethod, type UseMethodArgs, type Uses, type UsesArgs, collectionDetails, collectionDetailsToggle, getAddMemoInstruction, getAddMemoInstructionDataCodec, getAddMemoInstructionDataDecoder, getAddMemoInstructionDataEncoder, getCollectionCodec, getCollectionDecoder, getCollectionDetailsCodec, getCollectionDetailsDecoder, getCollectionDetailsEncoder, getCollectionDetailsToggleCodec, getCollectionDetailsToggleDecoder, getCollectionDetailsToggleEncoder, getCollectionEncoder, getCreateMetadataAccountV3DiscriminatorBytes, getCreateMetadataAccountV3Instruction, getCreateMetadataAccountV3InstructionDataCodec, getCreateMetadataAccountV3InstructionDataDecoder, getCreateMetadataAccountV3InstructionDataEncoder, getCreatorCodec, getCreatorDecoder, getCreatorEncoder, getDataV2Codec, getDataV2Decoder, getDataV2Encoder, getTokenMetadataAddress, getUseMethodCodec, getUseMethodDecoder, getUseMethodEncoder, getUsesCodec, getUsesDecoder, getUsesEncoder, hasSetComputeLimitInstruction, hasSetComputeUnitPriceInstruction, isCollectionDetails, isCollectionDetailsToggle, isSetComputeLimitInstruction, isSetComputeUnitPriceInstruction, parseAddMemoInstruction, parseCreateMetadataAccountV3Instruction };
