import { getCollectionDetailsEncoder, getCollectionDetailsDecoder } from '../chunk-VOK5RKS2.node.mjs';
export { CREATE_METADATA_ACCOUNT_V3_DISCRIMINATOR, TOKEN_METADATA_PROGRAM_ADDRESS, UseMethod, collectionDetails, getCollectionCodec, getCollectionDecoder, getCollectionDetailsCodec, getCollectionDetailsDecoder, getCollectionDetailsEncoder, getCollectionEncoder, getCreateMetadataAccountV3DiscriminatorBytes, getCreateMetadataAccountV3Instruction, getCreateMetadataAccountV3InstructionDataCodec, getCreateMetadataAccountV3InstructionDataDecoder, getCreateMetadataAccountV3InstructionDataEncoder, getCreatorCodec, getCreatorDecoder, getCreatorEncoder, getDataV2Codec, getDataV2Decoder, getDataV2Encoder, getTokenMetadataAddress, getUseMethodCodec, getUseMethodDecoder, getUseMethodEncoder, getUsesCodec, getUsesDecoder, getUsesEncoder, isCollectionDetails, parseCreateMetadataAccountV3Instruction } from '../chunk-VOK5RKS2.node.mjs';
export { hasSetComputeLimitInstruction, hasSetComputeUnitPriceInstruction, isSetComputeLimitInstruction, isSetComputeUnitPriceInstruction } from '../chunk-6NBZ7S5O.node.mjs';
export * from '@solana-program/system';
export * from '@solana-program/address-lookup-table';
export * from '@solana-program/compute-budget';
import { getStructEncoder, getUtf8Encoder, getStructDecoder, getUtf8Decoder, combineCodec, getDiscriminatedUnionEncoder, getUnitEncoder, getTupleEncoder, getDiscriminatedUnionDecoder, getUnitDecoder, getTupleDecoder } from '@solana/codecs';
import { AccountRole } from '@solana/instructions';

// src/programs/memo/generated/programs/memo.ts
var MEMO_PROGRAM_ADDRESS = "MemoSq4gqABAXKb96qnH8TysNcWxMyWCqXgDLGmfcHr";
var MemoInstruction = /* @__PURE__ */ ((MemoInstruction2) => {
  MemoInstruction2[MemoInstruction2["AddMemo"] = 0] = "AddMemo";
  return MemoInstruction2;
})(MemoInstruction || {});

// src/programs/memo/generated/instructions/addMemo.ts
function getAddMemoInstructionDataEncoder() {
  return getStructEncoder([["memo", getUtf8Encoder()]]);
}
function getAddMemoInstructionDataDecoder() {
  return getStructDecoder([["memo", getUtf8Decoder()]]);
}
function getAddMemoInstructionDataCodec() {
  return combineCodec(getAddMemoInstructionDataEncoder(), getAddMemoInstructionDataDecoder());
}
function getAddMemoInstruction(input, config) {
  const programAddress = config?.programAddress ?? MEMO_PROGRAM_ADDRESS;
  const args = { ...input };
  const remainingAccounts = (args.signers ?? []).map((signer) => ({
    address: signer.address,
    role: AccountRole.READONLY_SIGNER,
    signer
  }));
  const instruction = {
    accounts: remainingAccounts,
    programAddress,
    data: getAddMemoInstructionDataEncoder().encode(args)
  };
  return instruction;
}
function parseAddMemoInstruction(instruction) {
  return {
    programAddress: instruction.programAddress,
    data: getAddMemoInstructionDataDecoder().decode(instruction.data)
  };
}
function getCollectionDetailsToggleEncoder() {
  return getDiscriminatedUnionEncoder([
    ["None", getUnitEncoder()],
    ["Clear", getUnitEncoder()],
    ["Set", getStructEncoder([["fields", getTupleEncoder([getCollectionDetailsEncoder()])]])]
  ]);
}
function getCollectionDetailsToggleDecoder() {
  return getDiscriminatedUnionDecoder([
    ["None", getUnitDecoder()],
    ["Clear", getUnitDecoder()],
    ["Set", getStructDecoder([["fields", getTupleDecoder([getCollectionDetailsDecoder()])]])]
  ]);
}
function getCollectionDetailsToggleCodec() {
  return combineCodec(getCollectionDetailsToggleEncoder(), getCollectionDetailsToggleDecoder());
}
function collectionDetailsToggle(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isCollectionDetailsToggle(kind, value) {
  return value.__kind === kind;
}

export { MEMO_PROGRAM_ADDRESS, MemoInstruction, collectionDetailsToggle, getAddMemoInstruction, getAddMemoInstructionDataCodec, getAddMemoInstructionDataDecoder, getAddMemoInstructionDataEncoder, getCollectionDetailsToggleCodec, getCollectionDetailsToggleDecoder, getCollectionDetailsToggleEncoder, isCollectionDetailsToggle, parseAddMemoInstruction };
//# sourceMappingURL=index.node.mjs.map
//# sourceMappingURL=index.node.mjs.map